\documentclass[11pt,a4paper]{article}

\usepackage{amssymb, amsthm, enumerate, amsmath, pictexwd, mathrsfs, ../../yomcat, ../../diagrams}

\pagestyle{empty}

\theoremstyle{definition}
\newtheorem{Q}{Question}
\newtheorem*{sol}{Solution}
\newtheorem*{solution}{Solution}

\setlength\arraycolsep{2pt}
\setlength\headheight{0pt}
\setlength\headsep{0pt}
\setlength\textwidth{400pt}
\setlength\marginparwidth{0pt}

\makeatletter
\def\imod#1{\allowbreak\mkern10mu({\operator@font mod}\,\,#1)}
\makeatother

\setlength{\parskip}{1ex}
\setlength{\parindent}{0pt}

\begin{document}

\begin{center}
{\bf Victoria University of Wellington}\\[1ex]
{\bf School of Mathematics, Statistics \& Operations Research}\\
\end{center}

\hrule
MATH 409 \hfill
Assignment 8 \hfill
Michael Welsh (301012788)
\vspace{1ex}\hrule\vspace{1ex}

\begin{enumerate}
	\item \begin{enumerate}
		\item Assume that it does hold. That is, $\exists k \in \mbb{N}$ such that $f = g_k$. Therefore, $f(k) = g_k(k) = g_k(k) + 1$. This cannot happen, so $f \neq g_k\ \forall k \in \mbb{N}$.
		\item If $h$ is onto, then the range of $h$ is \mbc{F}. Say that $h(n) = g_n$, as in part (a). However, $f \in \mbc{F}$, but $h(n) \neq f\ \forall n \in \mbb{N}$. So, if $h$ is onto, it cannot be a function, and therefore it is not onto. \pend
	\end{enumerate}
	\item Run the computably enumerable algorithm for $A$. If $n \in A$, then it will show up at some point. If $m > n$ is ever outputted, then $n \notin A$. \\
	This algorithm will only take finitely many steps to tell you if $n \in A$ or $n \notin A$. Whenever it outputs $f(i)$, the set $\{ n\ |\ f(i - 1) < n < f(i) \}$ can be added to \ol{A}. So, after finitely many steps, either $n$ will be outputted or some $m > n$ will be outputted, for all $n \in \mbb{N}$.
	\item $f$ is computable, so there is an algorithm that returns $f(a)$ if $a \in A$ and otherwise doesn't end. Run this algorithm on $n$ members of \mbb{N} at the same time, for $m$ steps each, where $m$ is enough steps so that if $a \in A$ it will be outputted. As soon as a member of $A$ is found, or $m$ steps have been reached, start on the next member of \mbb{N}. \\
	This will only output members of $A$ as the original algorithm that does all the computing only outputs members of $A$ and nothing else.
	\item We already know (from lectures and tutorials) that multiplication and powers are primitive recursive functions.
		\begin{enumerate}
		\item $h(0) = 0! = 1$ \\
		$h(y+1) = (y+1)! = y! \cdot s(y)$
		\item $\ol{\textrm{sg}}(0) = 1$ \\
		$\ol{\textrm{sg}}(x + 1) = 0$
		\item $h(x,0) = x \uparrow 0 = 1$ \\
		$h(x, y + 1) = x \uparrow (y+1) = x^{x \uparrow y}$
	\end{enumerate}
\end{enumerate}

\end{document}